<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>SaslServerCallbackHandler.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.auth</a> &gt; <span class="el_source">SaslServerCallbackHandler.java</span></div><h1>SaslServerCallbackHandler.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.auth;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import javax.security.auth.callback.Callback;
import javax.security.auth.callback.CallbackHandler;
import javax.security.auth.callback.NameCallback;
import javax.security.auth.callback.PasswordCallback;
import javax.security.auth.callback.UnsupportedCallbackException;
import javax.security.auth.login.AppConfigurationEntry;
import javax.security.auth.login.Configuration;
import javax.security.sasl.AuthorizeCallback;
import javax.security.sasl.RealmCallback;

import org.apache.zookeeper.server.ZooKeeperSaslServer;

public class SaslServerCallbackHandler implements CallbackHandler {
    private static final String USER_PREFIX = &quot;user_&quot;;
<span class="fc" id="L41">    private static final Logger LOG = LoggerFactory.getLogger(SaslServerCallbackHandler.class);</span>
    private static final String SYSPROP_SUPER_PASSWORD = &quot;zookeeper.SASLAuthenticationProvider.superPassword&quot;;
    private static final String SYSPROP_REMOVE_HOST = &quot;zookeeper.kerberos.removeHostFromPrincipal&quot;;
    private static final String SYSPROP_REMOVE_REALM = &quot;zookeeper.kerberos.removeRealmFromPrincipal&quot;;

    private String userName;
<span class="fc" id="L47">    private final Map&lt;String,String&gt; credentials = new HashMap&lt;String,String&gt;();</span>

<span class="fc" id="L49">    public SaslServerCallbackHandler(Configuration configuration) throws IOException {</span>
<span class="fc" id="L50">        String serverSection = System.getProperty(ZooKeeperSaslServer.LOGIN_CONTEXT_NAME_KEY,</span>
                                                  ZooKeeperSaslServer.DEFAULT_LOGIN_CONTEXT_NAME);
<span class="fc" id="L52">        AppConfigurationEntry configurationEntries[] = configuration.getAppConfigurationEntry(serverSection);</span>

<span class="pc bpc" id="L54" title="1 of 2 branches missed.">        if (configurationEntries == null) {</span>
<span class="nc" id="L55">            String errorMessage = &quot;Could not find a 'Server' entry in this configuration: Server cannot start.&quot;;</span>
<span class="nc" id="L56">            LOG.error(errorMessage);</span>
<span class="nc" id="L57">            throw new IOException(errorMessage);</span>
        }
<span class="fc" id="L59">        credentials.clear();</span>
<span class="fc bfc" id="L60" title="All 2 branches covered.">        for(AppConfigurationEntry entry: configurationEntries) {</span>
<span class="fc" id="L61">            Map&lt;String,?&gt; options = entry.getOptions();</span>
            // Populate DIGEST-MD5 user -&gt; password map with JAAS configuration entries from the &quot;Server&quot; section.
            // Usernames are distinguished from other options by prefixing the username with a &quot;user_&quot; prefix.
<span class="fc bfc" id="L64" title="All 2 branches covered.">            for(Map.Entry&lt;String, ?&gt; pair : options.entrySet()) {</span>
<span class="fc" id="L65">                String key = pair.getKey();</span>
<span class="pc bpc" id="L66" title="1 of 2 branches missed.">                if (key.startsWith(USER_PREFIX)) {</span>
<span class="fc" id="L67">                    String userName = key.substring(USER_PREFIX.length());</span>
<span class="fc" id="L68">                    credentials.put(userName,(String)pair.getValue());</span>
                }
<span class="fc" id="L70">            }</span>
        }
<span class="fc" id="L72">    }</span>

    public void handle(Callback[] callbacks) throws UnsupportedCallbackException {
<span class="fc bfc" id="L75" title="All 2 branches covered.">        for (Callback callback : callbacks) {</span>
<span class="fc bfc" id="L76" title="All 2 branches covered.">            if (callback instanceof NameCallback) {</span>
<span class="fc" id="L77">                handleNameCallback((NameCallback) callback);</span>
<span class="fc bfc" id="L78" title="All 2 branches covered.">            } else if (callback instanceof PasswordCallback) {</span>
<span class="fc" id="L79">                handlePasswordCallback((PasswordCallback) callback);</span>
<span class="fc bfc" id="L80" title="All 2 branches covered.">            } else if (callback instanceof RealmCallback) {</span>
<span class="fc" id="L81">                handleRealmCallback((RealmCallback) callback);</span>
<span class="pc bpc" id="L82" title="1 of 2 branches missed.">            } else if (callback instanceof AuthorizeCallback) {</span>
<span class="fc" id="L83">                handleAuthorizeCallback((AuthorizeCallback) callback);</span>
            }
        }
<span class="fc" id="L86">    }</span>

    private void handleNameCallback(NameCallback nc) {
        // check to see if this user is in the user password database.
<span class="pc bpc" id="L90" title="1 of 2 branches missed.">        if (credentials.get(nc.getDefaultName()) == null) {</span>
<span class="nc" id="L91">            LOG.warn(&quot;User '&quot; + nc.getDefaultName() + &quot;' not found in list of DIGEST-MD5 authenticateable users.&quot;);</span>
<span class="nc" id="L92">            return;</span>
        }
<span class="fc" id="L94">        nc.setName(nc.getDefaultName());</span>
<span class="fc" id="L95">        userName = nc.getDefaultName();</span>
<span class="fc" id="L96">    }</span>

    private void handlePasswordCallback(PasswordCallback pc) {
<span class="pc bpc" id="L99" title="1 of 4 branches missed.">        if (&quot;super&quot;.equals(this.userName) &amp;&amp; System.getProperty(SYSPROP_SUPER_PASSWORD) != null) {</span>
            // superuser: use Java system property for password, if available.
<span class="nc" id="L101">            pc.setPassword(System.getProperty(SYSPROP_SUPER_PASSWORD).toCharArray());</span>
<span class="pc bpc" id="L102" title="1 of 2 branches missed.">        } else if (credentials.containsKey(userName) ) {</span>
<span class="fc" id="L103">            pc.setPassword(credentials.get(userName).toCharArray());</span>
        } else {
<span class="nc" id="L105">            LOG.warn(&quot;No password found for user: &quot; + userName);</span>
        }
<span class="fc" id="L107">    }</span>

    private void handleRealmCallback(RealmCallback rc) {
<span class="fc" id="L110">        LOG.debug(&quot;client supplied realm: &quot; + rc.getDefaultText());</span>
<span class="fc" id="L111">        rc.setText(rc.getDefaultText());</span>
<span class="fc" id="L112">    }</span>

    private void handleAuthorizeCallback(AuthorizeCallback ac) {
<span class="fc" id="L115">        String authenticationID = ac.getAuthenticationID();</span>
<span class="fc" id="L116">        String authorizationID = ac.getAuthorizationID();</span>

<span class="fc" id="L118">        LOG.info(&quot;Successfully authenticated client: authenticationID=&quot; + authenticationID</span>
                + &quot;;  authorizationID=&quot; + authorizationID + &quot;.&quot;);
<span class="fc" id="L120">        ac.setAuthorized(true);</span>

        // canonicalize authorization id according to system properties:
        // zookeeper.kerberos.removeRealmFromPrincipal(={true,false})
        // zookeeper.kerberos.removeHostFromPrincipal(={true,false})
<span class="fc" id="L125">        KerberosName kerberosName = new KerberosName(authenticationID);</span>
        try {
<span class="fc" id="L127">            StringBuilder userNameBuilder = new StringBuilder(kerberosName.getShortName());</span>
<span class="pc bpc" id="L128" title="1 of 2 branches missed.">            if (shouldAppendHost(kerberosName)) {</span>
<span class="nc" id="L129">                userNameBuilder.append(&quot;/&quot;).append(kerberosName.getHostName());</span>
            }
<span class="pc bpc" id="L131" title="1 of 2 branches missed.">            if (shouldAppendRealm(kerberosName)) {</span>
<span class="nc" id="L132">                userNameBuilder.append(&quot;@&quot;).append(kerberosName.getRealm());</span>
            }
<span class="fc" id="L134">            LOG.info(&quot;Setting authorizedID: &quot; + userNameBuilder);</span>
<span class="fc" id="L135">            ac.setAuthorizedID(userNameBuilder.toString());</span>
<span class="nc" id="L136">        } catch (IOException e) {</span>
<span class="nc" id="L137">            LOG.error(&quot;Failed to set name based on Kerberos authentication rules.&quot;);</span>
<span class="fc" id="L138">        }</span>
<span class="fc" id="L139">    }</span>

    private boolean shouldAppendRealm(KerberosName kerberosName) {
<span class="pc bpc" id="L142" title="2 of 4 branches missed.">        return !isSystemPropertyTrue(SYSPROP_REMOVE_REALM) &amp;&amp; kerberosName.getRealm() != null;</span>
    }

    private boolean shouldAppendHost(KerberosName kerberosName) {
<span class="pc bpc" id="L146" title="2 of 4 branches missed.">        return !isSystemPropertyTrue(SYSPROP_REMOVE_HOST) &amp;&amp; kerberosName.getHostName() != null;</span>
    }

    private boolean isSystemPropertyTrue(String propertyName) {
<span class="fc" id="L150">        return &quot;true&quot;.equals(System.getProperty(propertyName));</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>